import os
import sys
import zipfile
import json
import requests
import subprocess
import threading
import time
import datetime


HOME_DIR = os.path.abspath("/mnt/data/")
# HOME_DIR = "/home/fabian/mnt/data/"

REG_URL = 'http://flexa.barix.cloud/api/DeviceGet'
REG_URL = 'https://flexa.azurewebsites.net/api/DeviceGet'

REG_PATH = os.path.join(HOME_DIR, "regId")
CONFIG_PATH = os.path.join(HOME_DIR, "")
APP_DIR = os.path.join(HOME_DIR,"package")
APP_PATH = os.path.join(APP_DIR,"run.py")
LUA_APP_PATH = os.path.join(APP_DIR,"default.lua")
TMP_CRON_PATH = "/var/spool/cron/root"

new_app_linu = False
new_app_usb = False

def daemonize_app():
    pid = os.getpid()
    with open("/var/flexa-daemon.pid","w") as op:
        op.write("%s" %pid)

        
def get_language():
    return os.path.isfile(os.path.join(APP_DIR,"run.py"))
        
        
def get_app_version():
    # TODO
    return 0


def get_regid():
    if os.path.isfile(REG_PATH):
        with open(REG_PATH, 'r') as reg:
            regId = reg.read()
            return regId
	return 0

def log(message):
    subprocess.Popen("logger "+message, shell = True)


def get_timestamp():
    ts = time.time()
    st = datetime.datetime.fromtimestamp(ts).strftime('%Y-%m-%d %H:%M:%S')
    return st


def connect(obj,callback,params,interval):
    counter = 0
    while (not obj and counter < 3):
        obj = callback(params)
        counter += 1
        time.sleep(interval)
        
    if not obj:
        # shutdown if no connection
        # sys.exit(500)
        log("could not establish connection to linuquick, getting app and config from local source!")
    return obj
    
    
def post_request(params):
    log("send post request to"+str(params[0]))
    try:
        request = requests.post(params[0],json=params[1])
        log("Response: "+str(request.content))
        if request.status_code == 200:
            return request.json()
        else:
            return 0
        
    except requests.exceptions.RequestException as e:
        log("failed to connect to"+str(params[0]))
        return 0
    
    
def get_app(callback,package_url):
    try: 
        kill_prc = subprocess.check_call(["pkill", "-9", "-f", "run.py"])
    except subprocess.CalledProcessError as e:
        log(str(e.output))
    package_path = callback(package_url)

    if package_path:
        zip_app = zipfile.ZipFile(package_path, 'r')
        zip_app.extractall(HOME_DIR)
        zip_app.close()
        for file in os.listdir(HOME_DIR):
            if file.endswith(".json"):
                move_configs = subprocess.Popen("mv "+file+" "+APP_DIR, shell = True)
                move_configs.wait()
        return True

    
def download_package(package_url):

    package_url = package_url.replace("https","http")
    wget_prc = subprocess.Popen("wget --output-document="+os.path.join(HOME_DIR, "package.zip") +
                                " " + package_url, shell = True)
    wget_prc.wait()
    return os.path.join(HOME_DIR, "package.zip")
					 

def find_local_package(package_path):
    # if a usb is plugged in,  the mountusb script (triggered by udev) will copy its relevant
    # content to /mnt/data/new_package -> this function gets config.json + package.zip from there
    if os.path.isdir(package_path):
        files = os.listdir(package_path)
        if files: 
            for file in files:
                if file.endswith(".json"):
                    copy_config = subprocess.Popen("cp "+os.path.join(package_path,file)+" "+HOME_DIR, shell = True)
                    copy_config.wait()
            copy_package = subprocess.Popen("cp "+package_path+"/package.zip "+HOME_DIR, shell = True)
            copy_package.wait()
            print("rm -rf "+package_path)
            delete = subprocess.Popen("rm -rf "+package_path, shell = True)
            delete.wait()
            return os.path.join(HOME_DIR,"package.zip")
        else: 
            return ""
    
def run_app():
    is_python = get_language()
    print(is_python)
    if is_python:
        try:
            stop_prc = subprocess.Popen("/etc/init.d/run-flexa stop", shell = True)
            stop_prc.wait()        
            start_prc = subprocess.Popen("/usr/bin/python "+APP_PATH, shell = True)
            start_prc.wait()
            return True
        except subprocess.CalledProcessError as e:
            log(str(e.output))
            return False
    else:
        try:
            stop_prc = subprocess.Popen("/etc/init.d/run-flexa stop", shell = True)
            stop_prc.wait()        
            start_prc = subprocess.Popen("/usr/bin/lua5.1 "+LUA_APP_PATH, shell = True)
            start_prc.wait()
            return True
        except subprocess.CalledProcessError as e:
            log(str(e.output))
            return False

    
def create_cron_job(interval):
    # curently we assume the interval is hardcoded to once a day. 
    APP = "/etc/init.d/flexa-daemon start\n"
    date = "0 1  * * * "
    
    with open(TMP_CRON_PATH,"a") as mycron:
        mycron.write(date+APP)
    command = "crontab "+TMP_CRON_PATH  
    write_crontab = subprocess.Popen(command, shell = True)
    
    
def main():
    daemonize_app()
    # stop_flexa = subprocess.Popen("/etc/init.d/run-flexa stop", shell = True)
    service_url = None
    service_info = None
    configuration = None
    app_version = get_app_version();
    regid = get_regid();
    
    # try to connect the registy 3 times  
    service_url = connect(service_url,post_request,[REG_URL, {"regId":regid}],2)   
    if service_url:
        service_info = connect(service_info,post_request,
                               [service_url["url"]+"/GetURL",{}],2)
        configuration = connect(configuration,post_request,[service_info["configUrl"],
                                                            {"regId":regid}],2)
        # try to fetch package from web service
        new_app_linu = get_app(download_package,service_info["packageUrl"])
            # write the configuration to json files
        with open(os.path.join(APP_DIR, "config.json"), 'w') as config:
            json.dump(configuration, config)
        with open(os.path.join(APP_DIR, "service.json"), 'w') as service:
            json.dump(service_info, service)
    
    # try to fetch package from USB drive
    new_app_usb = get_app(find_local_package, os.path.join(HOME_DIR,"new_package"))
        
    n_attempts = 0
    app_initialized = False
    # while not app_initialized and (n_attempts < 3):
    #    app_initialized = run_app()
    #    n_attempts += 1
    if new_app_usb or new_app_linu:
        subprocess.Popen("/etc/init.d/reboot", shell = True)
    
    create_cron_job(1)
    
    

if __name__ == "__main__":
    main()
