#!/bin/sh
# Script for updating audioplex. It is run by audioplex, perfroming a version check and running the update when new version is available.
# Ussage: ./update-script
#
CONFFILE=/mnt/data/update_servers.txt
if [ -f ${CONFFILE} ]; then
	echo "Old config file ${CONFFILE} exists. Deleting it"
	rm ${CONFFILE}
fi

set -e
 
scriptname=$(basename $0)
lock="/var/run/${scriptname}"

exec 200>$lock
flock -n 200 || exit 1
. /tmp/update_vars

echo $PKG_URL
echo "Package version is $PKG_VER"
CURR_VER=`cat /barix/info/VERSION`
echo "Current version is $CURR_VER"
if [ "$PKG_VER" = "$CURR_VER" ]; then
        echo "No new version detected quiting"
        exit 0
fi
if grep -q mmcblk0p4 /etc/mtab ; then
	echo "SD partion found. Scheduling new update for qiba-update-client"
        echo $PKG_URL > ${CONFFILE}
# Uncomment the line below to force update righ away, otherwise it will be done between 4:00 and 4:30 AM
#	/usr/bin/qiba-update-client
	exit 0
fi

logger -t "update-script" -p daemon.warn "No data partion on SD card found. FW will not work properly. Skipping update!"
#TODO: See how to force rescue mode in the future
exit 1
