<% . /usr/local/lib/cgi/haserl.sh ; check_instances uinetwork.cgi %>
<% . /usr/local/lib/cgi/generic.sh ; print_http_hdr %>
<% . /usr/local/lib/cgi/status.sh %>
<% . /usr/local/lib/cgi/config.sh %>
<html>
<head>
<meta http-equiv="Content-type" content="text/html;charset=UTF-8">
<title>Development Kit - Settings</title>
<link href="/sys/css/settings.css" rel="stylesheet" type="text/css">
<script type="text/javascript" src="/sys/js/util.js"></script>
<script language="javascript">

var is_firefox = navigator.userAgent.toLowerCase().indexOf('firefox') > -1;

/* password check */
function validatePassword(){
  	var password = document.getElementById("pwd_set");
	var password_chk = document.getElementById("pwd_chk");
	var ret=false;
  	if(password.value != password_chk.value) {
    	alert("Passwords don't match! Please correct them before submitting your changes!");
  	} else {
    	ret=true;
  	}
  	return ret;
}

/* hide html table row */
function hide_tr(id){
	el=document.getElementById(id);
	if (el) el.style.display='none';
}

/* show html table row
   Latest version of Firefox use "block" to show previously
   hidden table row when style.display='' is used in JS code
   This causes problems with select options drop down menus
   not being selectable with the mouse, so handle it
   it here differently here */
function show_tr(id){
       	el=document.getElementById(id);
	if (el){
		if (is_firefox){
			el.style.display='table-row';
            	}else{
			el.style.display='';
            	}
	}
}
/* playlist settings */

function visualize_playlist_settings(app_type){
    if (app_type == 'portal'){
        hide_tr('failover_url');
        hide_tr('main_url');
        hide_tr('player_vol');
        hide_tr('download_server');
        show_tr('portal_url');
    }else{
        show_tr('main_url');    
        show_tr('failover_url');    
        show_tr('player_vol');    
        show_tr('download_server');
        hide_tr('portal_url');
    }
}
function initPlaylistPage(){
	visualize_playlist_settings(document.getElementById('application_type').value);
}

/* local network params show function */

function view_network_settings(show_static){
        if (show_static == "static"){                                                         
	        show_tr('ip_addr');                                             
                show_tr('netmask');                                             
        	show_tr('gateway');                                             
                show_tr('dns1');                                                
                show_tr('dns2');                                                
                hide_tr('dhcp_name');                                           
        }else{                          
		hide_tr('ip_addr');                                             
		hide_tr('netmask');                                             
		hide_tr('gateway');                                             
		hide_tr('dns1');                                                
		hide_tr('dns2');                                                
		show_tr('dhcp_name');                                           
	}
}

function initNetworkPage(){
	view_network_settings(document.getElementById('net_proto').value);
}

function checkIntInputValue(elem,minVal,maxVal,defVal)
{
	// get the entered value
	var newValue=elem.value;
	// if not set, use the default
	if ( newValue == "" ) newValue = defVal;
	// the value must be integer number
	var newValNum=parseInt(newValue, 10);
	// ... and in the range of min-max
	if ( newValNum > maxVal ) newValNum = maxVal;
	if ( newValNum < minVal ) newValNum = minVal;
	if ( newValue != newValNum ){
		elem.value = newValNum;
	}
}

function checkHostName(elem)
{
        var hostName=elem.value;
        if (!/^[-A-Za-z0-9\.]*$/.test(hostName)){
                alert('This is a non valid hostname! Characters from A to Z, from a to z, from 0 to 9, . and - only are admitted!');
                elem.value=elem.defaultValue;
        }
}
</script>
<style type="text/css">
</style>
</head>
<body onload="initNetworkPage();initPlaylistPage();">

<form name="settings" action=config.cgi method=POST>
<input type=hidden name=return_page value=cgi-bin/uinetwork.cgi>

<table>    
        <col style="width:120px">                                                
        <col style="width:480px">                                
	<tr>
		<td colspan="2"><br><b>MAIN APPLICATION SETTINGS</b></td>
	</tr>

	<tr>
		<td><font size=2><b>Application Mode</b></font></td>
                <td>
                    <select size="1" width="140px" id="application_type" name="application.main_config.application_type" onchange="visualize_playlist_settings(this.value)">
                        <option value="portal" <% if cfg_string_compare application.main_config.application_type portal ; then echo -n "selected"; fi %>>portal</option>
                        <option value="stand-alone" <% if cfg_string_compare application.main_config.application_type stand-alone ; then echo -n "selected"; fi %>>stand-alone</option>
                    </select>    
                 </td>
	</tr>

	<tr id="player_vol">
		<td><font size=2><b>Player Volume</b></font></td>
        <td><select size="1" width="140px" id="player_volume" name="application.audio.player_volume_percent">
            <option value="0" <% if cfg_string_compare application.audio.player_volume_percent 0 ; then echo -n "selected"; fi %>>0 %</option>
            <option value="5" <% if cfg_string_compare application.audio.player_volume_percent 5 ; then echo -n "selected"; fi %>>5 %</option>
            <option value="10" <% if cfg_string_compare application.audio.player_volume_percent 10 ; then echo -n "selected"; fi %>>10 %</option>
            <option value="15" <% if cfg_string_compare application.audio.player_volume_percent 15 ; then echo -n "selected"; fi %>>15 %</option>
            <option value="20" <% if cfg_string_compare application.audio.player_volume_percent 20 ; then echo -n "selected"; fi %>>20 %</option>
            <option value="25" <% if cfg_string_compare application.audio.player_volume_percent 25 ; then echo -n "selected"; fi %>>25 %</option>
            <option value="30" <% if cfg_string_compare application.audio.player_volume_percent 30 ; then echo -n "selected"; fi %>>30 %</option>
            <option value="35" <% if cfg_string_compare application.audio.player_volume_percent 35 ; then echo -n "selected"; fi %>>35 %</option>
            <option value="40" <% if cfg_string_compare application.audio.player_volume_percent 40 ; then echo -n "selected"; fi %>>40 %</option>
            <option value="45" <% if cfg_string_compare application.audio.player_volume_percent 45 ; then echo -n "selected"; fi %>>45 %</option>
            <option value="50" <% if cfg_string_compare application.audio.player_volume_percent 50 ; then echo -n "selected"; fi %>>50 %</option>
            <option value="55" <% if cfg_string_compare application.audio.player_volume_percent 55 ; then echo -n "selected"; fi %>>55 %</option>
            <option value="60" <% if cfg_string_compare application.audio.player_volume_percent 60 ; then echo -n "selected"; fi %>>60 %</option>
            <option value="65" <% if cfg_string_compare application.audio.player_volume_percent 65 ; then echo -n "selected"; fi %>>65 %</option>
            <option value="70" <% if cfg_string_compare application.audio.player_volume_percent 70 ; then echo -n "selected"; fi %>>70 %</option>
            <option value="75" <% if cfg_string_compare application.audio.player_volume_percent 75 ; then echo -n "selected"; fi %>>75 %</option>
            <option value="80" <% if cfg_string_compare application.audio.player_volume_percent 80 ; then echo -n "selected"; fi %>>80 %</option>
            <option value="85" <% if cfg_string_compare application.audio.player_volume_percent 85 ; then echo -n "selected"; fi %>>85 %</option>
            <option value="90" <% if cfg_string_compare application.audio.player_volume_percent 90 ; then echo -n "selected"; fi %>>90 %</option>
            <option value="95" <% if cfg_string_compare application.audio.player_volume_percent 95 ; then echo -n "selected"; fi %>>95 %</option>
            <option value="100" <% if cfg_string_compare application.audio.player_volume_percent 100 ; then echo -n "selected"; fi %>>100 %</option>
         </td>
	</tr>

	<tr>
		<td><font size=2><b>Priority URL</b></font></td>
		<td>
		     <input name="application.main_config.priority_url" size="40" maxlength="1024" value="<% cfg_print_param application.main_config.priority_url %>" >
        </td>
	</tr>

	<tr id="main_url">
		<td><font size=2><b>Main URL</b></font></td>
		<td>
		     <input name="application.main_config.playback_url" size="40" maxlength="1024" value="<% cfg_print_param application.main_config.playback_url %>" >
        </td>
	</tr>

	<tr id="failover_url">
		<td><font size=2><b>Failover URL</b></font></td>
		<td>
		     <input name="application.main_config.failover_url" size="40" maxlength="1024" value="<% cfg_print_param application.main_config.failover_url %>" >
        </td>
	</tr>

	<tr id="portal_url">
		<td><font size=2><b>Portal URL</b></font></td>
		<td>
		     <input name="application.main_config.backend_url" size="40" maxlength="1024" value="<% cfg_print_param application.main_config.backend_url %>" >
        </td>
	</tr>

</table> 

<table>    
        <col style="width:120px">                                                
        <col style="width:480px">                                
	<tr>
		<td colspan="2"><br><b>FAILOVER PLAYLIST SETTINGS</b></td>
	</tr>

	<tr id="download_server">
		<td><font size=2><b>Server URL</b></font></td>
		<td>
		     <input name="application.playlist.server_url" size="40" maxlength="1024" value="<% cfg_print_param application.playlist.server_url %>" >
        </td>
	</tr>

	<tr>
		<td><font size=2><b>Local Folder</b></font></td>
		<td>
		     <input name="application.playlist.local_folder" size="30" maxlength="1024" value="<% cfg_print_param application.playlist.local_folder %>" >
        </td>
	</tr>

</table> 

<table>    
        <col style="width:120px">                                                
        <col style="width:480px">                                
	<tr>
		<td colspan="2"><br><b>METADATA FORWARDING SETTINGS</b></td>
	</tr>

	<tr>
		<td><font size=2><b>UDP Port</b></font></td>
		<td>
		     <input name="application.main_config.meta_udp_port" size="5" maxlength="5" value="<% cfg_print_param application.main_config.meta_udp_port %>" onChange="PortCheckZero(this,0)">
        </td>
	</tr>

</table> 

<table>    
        <col style="width:120px">                                                
        <col style="width:480px">                                
	<tr>
		<td colspan="2"><br><b>BARIMON SETTINGS</b></td>
	</tr>

	<tr>
		<td><font size=2><b>Barimon URL</b></font></td>
		<td>
		     <input name="application.barimon.server_address" size="40" maxlength="1024" value="<% cfg_print_param application.barimon.server_address %>" >
        </td>
	</tr>
	<tr>
		<td><font size=2><b>Barimon Port</b></font></td>
		<td>
		     <input name="application.barimon.server_port" size="5" maxlength="5" value="<% cfg_print_param application.barimon.server_port %>" onChange="PortCheck(this,1)">
        </td>
	</tr>
	<tr>
		<td><font size=2><b>Barimon Interval</b></font></td>
		<td>
		     <input name="application.barimon.interval_minutes" size="5" maxlength="5" value="<% cfg_print_param application.barimon.interval_minutes %>" onChange="intCheck(this,1,32768)"> minutes
        </td>
	</tr>

</table>

<table>
	<col style="width:120px">
	<col style="width:480px">
	<tr>
		<td colspan="2"><br><b>NETWORK SETTINGS</b></td>
	</tr>
	<tr>
		<td><font size=2><b>Use SonicIP</b></font></td>
        <td><font size=2><% form_print_radio network.sonic_ip.enabled Yes No %> </font>
        </td>
	</tr>
	<tr>
		<td><font size=2><b>SonicIP Volume</b></font></td>
        <td><select size="1" width="140px" id="sonicc_vol" name="network.sonic_ip.volume">
            <option value="0%" <% if cfg_string_compare network.sonic_ip.volume 0% ; then echo -n "selected"; fi %>>0 %</option>
            <option value="10%" <% if cfg_string_compare network.sonic_ip.volume 10% ; then echo -n "selected"; fi %>>10 %</option>
            <option value="20%" <% if cfg_string_compare network.sonic_ip.volume 20% ; then echo -n "selected"; fi %>>20 %</option>
            <option value="30%" <% if cfg_string_compare network.sonic_ip.volume 30% ; then echo -n "selected"; fi %>>30 %</option>
            <option value="40%" <% if cfg_string_compare network.sonic_ip.volume 40% ; then echo -n "selected"; fi %>>40 %</option>
            <option value="50%" <% if cfg_string_compare network.sonic_ip.volume 50% ; then echo -n "selected"; fi %>>50 %</option>
            <option value="60%" <% if cfg_string_compare network.sonic_ip.volume 60% ; then echo -n "selected"; fi %>>60 %</option>
            <option value="70%" <% if cfg_string_compare network.sonic_ip.volume 70% ; then echo -n "selected"; fi %>>70 %</option>
            <option value="80%" <% if cfg_string_compare network.sonic_ip.volume 80% ; then echo -n "selected"; fi %>>80 %</option>
            <option value="90%" <% if cfg_string_compare network.sonic_ip.volume 90% ; then echo -n "selected"; fi %>>90 %</option>
            <option value="100%" <% if cfg_string_compare network.sonic_ip.volume 100% ; then echo -n "selected"; fi %>>100 %</option>
         </td>
	</tr>
	<tr>
	        <td><font size=2><b>Protocol</b></font></td>
		<td>
			<select size="1" width="140px" id="net_proto" name="network.eth0.proto" onchange="view_network_settings(this.value)">
				<option value="dhcp" <% if cfg_string_compare network.eth0.proto dhcp ; then echo -n "selected"; fi %>>DHCP</option>
				<option value="static" <% if cfg_string_compare network.eth0.proto static ; then echo -n "selected"; fi %>>Static</option>
			</select>
	        </td>   
	</tr>		
	<tr id="ip_addr" >
		<td><font size=2><b>IP Address</b></font></td>
		<td><font size=2><input name="network.eth0.ipaddr" size="16" maxlength="15" value="<% cfg_print_param network.eth0.ipaddr %>" onChange="IPAddrCheck(this,0)"></font></td>
	</tr>
	<tr id="netmask" >
		<td><font size=2><b>Netmask</b></font></td>
		<td><font size=2><input name="network.eth0.netmask" size="16" maxlength="15" value="<% cfg_print_param network.eth0.netmask %>" onChange="NetmaskCheck(this)"></font>
        </td>
	</tr>
	<tr id="gateway" >
		<td><font size=2><b>Gateway IP Address</b></font></td>
		<td><font size=2><input name="network.eth0.gateway" size="16" maxlength="15" value="<% cfg_print_param network.eth0.gateway %>" onChange="IPAddrCheck(this,1)"></font>
        </td>
	</tr>
	<tr id="dns1" >
		<td><font size=2><b>Primary DNS</b></font></td>
		<td><font size=2><input name="network.eth0.dns1" size="16" maxlength="15" value="<% cfg_print_param network.eth0.dns1 %>" onChange="IPAddrCheck(this,1)"></font>
        </td>
	</tr>
	<tr id="dns2" >
		<td><font size=2><b>Alternative&nbsp;DNS</b></font></td>
		<td><font size=2><input name="network.eth0.dns2" size="16" maxlength="15" value="<% cfg_print_param network.eth0.dns2 %>" onChange="IPAddrCheck(this,1)"></font>
        </td>
	</tr>
	<tr id="dhcp_name">
		<td><font size=2><b>DHCP Host Name</b></font></td>
		<td>
		     <input name="network.eth0.dhcpname" size="20" maxlength="32" value="<% cfg_print_param network.eth0.dhcpname %>" onChange="checkHostName(this)">
        </td>
	</tr>
	<tr>
		<td><font size=2><b>Web Server Port</b></font></td>
		<td>
		     <input name="httpd.webserver.port" size="5" maxlength="5" value="<% cfg_print_param httpd.webserver.port %>" onChange="PortCheck(this,1)">
        </td>
	</tr>
</table>

<table>
        <col style="width:120px">                                                
        <col style="width:480px"> 
	<tr>
		<td colspan="2"><br><b>SECURITY SETTINGS</b></td>
<!--	<tr>
		<td>Reboot Function
		<td><% form_print_radio security.reset.enabled Enabled Disabled %>
	<tr>
		<td>Reset Factory Defaults
		<td><% form_print_radio security.defaults.enabled Enabled Disabled %>
	<tr>
		<td>Update Function
		<td><% form_print_radio security.update.enabled Enabled Disabled %>
-->		
<%
if cfg_string_compare httpd.webserver.password_set "" ; then
      echo -n "
    <tr>
		<td><font size=2><b>Web UI Password</b></font></td>
		<td>
			<input name='pwd_set' id='pwd_set' type=password size='16' maxlength='16' placeholder='Password'>
			<input id='pwd_chk' type=password size='16' maxlength='16' placeholder='Confirm Password'>
		</td>
	
	       "
else
      echo -n "
        <tr> 
	        <td><font size=2><b>Change Password</b></font></td>
		<td>
			<input name='pwd_old' type=password size='16' maxlength='16' placeholder='Old Password'>
			<input name='pwd_new' id='pwd_set' type=password size='16' maxlength='16' placeholder='New Password'>
			<input id='pwd_chk' type=password size='16' maxlength='16' placeholder='Confirm Password'>
		 </td>
	       "
fi
%>
	<tr>
		<td colspan="2"><hr size="1" noshade></td>
     </tr>   
	<tr>
		<td colspan="2">
		<input type=submit value="Submit" formtarget="_self" onClick="return validatePassword();"><input type=reset value="Cancel">
        </td>
    </tr>    
</table>
</form>
</body>
</html>
